   This file documents GNU automake 1.2

   Copyright (C) 1995, 96, 97 Free Software Foundation, Inc.

   Permission is granted to make and distribute verbatim copies of this
manual provided the copyright notice and this permission notice are
preserved on all copies.

   Permission is granted to copy and distribute modified versions of
this manual under the conditions for verbatim copying, provided that
the entire resulting derived work is distributed under the terms of a
permission notice identical to this one.

   Permission is granted to copy and distribute translations of this
manual into another language, under the above conditions for modified
versions, except that this permission notice may be stated in a
translation approved by the Foundation.

Yacc and Lex support
====================

   Automake has somewhat idiosyncratic support for Yacc and Lex.

   Automake assumes that the `.c' file generated by yacc (or lex)
should be named using the basename of the input file.  That is, for a
yacc source file `foo.y', automake will cause the intermediate file to
be named `foo.c' (as opposed to `y.tab.c', which is more traditional).

   The extension of a yacc source file is used to determine the
extension of the resulting `C' or `C++' file.  Files with the extension
`.y' will be turned into `.c' files; likewise, `.yy' will become `.cc';
`.y++', `c++'; and `.yxx', `.cxx'.  Likewise, lex source files can be
used to generate `C' or `C++'; the extensions `.l', `.ll', `.l++', and
`.lxx' are recognized.

   You should never explicitly mention the intermediate (`C' or `C++')
file in any `SOURCES' variable; only list the source file.

   The intermediate files generated by yacc (or lex) will be included in
any distribution that is made.  That way the user doesn't need to have
yacc or lex.

   If a yacc source file is seen, then your `configure.in' must define
the variable `YACC'.  This is most easily done by invoking the macro
`AC_PROG_YACC'.

   Similarly, if a lex source file is seen, then your `configure.in'
must define the variable `LEX'.  You can use `AC_PROG_LEX' to do this.
Automake's lex support also requires that you use the `AC_DECL_YYTEXT'
macro--automake needs to know the value of `LEX_OUTPUT_ROOT'.

   Any program including a lex source file must be linked against
`@LEXLIB@'.  You can do this by putting `@LEXLIB@' into the appropriate
`LDADD' variable.

   Automake makes it possible to include multiple yacc (or lex) source
files in a single program.  Automake uses a small program called
`ylwrap' to run `yacc' (or `lex') in a subdirectory.  This is necessary
because yacc's output filename is fixed, and a parallel make could
conceivably invoke more than one instance of `yacc' simultaneously.
`ylwrap' is distributed with automake.  It should appear in the
directory specified by `AC_CONFIG_AUX_DIR', or the current directory if
that macro is not used in `configure.in'.

   For `yacc', simply managing locking is insufficient.  `yacc' output
also always uses the same symbol names internally, so it isn't possible
to link two `yacc' parsers into the same executable.

   We recommend using the following renaming hack used in `gdb':
     #define	yymaxdepth c_maxdepth
     #define	yyparse	c_parse
     #define	yylex	c_lex
     #define	yyerror	c_error
     #define	yylval	c_lval
     #define	yychar	c_char
     #define	yydebug	c_debug
     #define	yypact	c_pact
     #define	yyr1	c_r1
     #define	yyr2	c_r2
     #define	yydef	c_def
     #define	yychk	c_chk
     #define	yypgo	c_pgo
     #define	yyact	c_act
     #define	yyexca	c_exca
     #define yyerrflag c_errflag
     #define yynerrs	c_nerrs
     #define	yyps	c_ps
     #define	yypv	c_pv
     #define	yys	c_s
     #define	yy_yys	c_yys
     #define	yystate	c_state
     #define	yytmp	c_tmp
     #define	yyv	c_v
     #define	yy_yyv	c_yyv
     #define	yyval	c_val
     #define	yylloc	c_lloc
     #define yyreds	c_reds
     #define yytoks	c_toks
     #define yylhs	c_yylhs
     #define yylen	c_yylen
     #define yydefred c_yydefred
     #define yydgoto	c_yydgoto
     #define yysindex c_yysindex
     #define yyrindex c_yyrindex
     #define yygindex c_yygindex
     #define yytable	 c_yytable
     #define yycheck	 c_yycheck

   For each define, replace the `c_' prefix with whatever you like.
These defines work for `bison', `byacc', and traditional `yacc's.  If
you find a parser generator that uses a symbol not covered here, please
report the new name so it can be added to the list.

C++ and other languages
=======================

   Automake includes full support for C++, and rudimentary support for
other languages.  Support for other languages will be improved based on
demand.

   Any package including C++ code must define the output variable `CXX'
in `configure.in'; the simplest way to do this is to use the
`AC_PROG_CXX' macro.

   A few additional variables are defined when a C++ source file is
seen:

`CXX'
     The name of the C++ compiler.

`CXXFLAGS'
     Any flags to pass to the C++ compiler.

`CXXCOMPILE'
     The command used to actually compile a C++ source file.  The file
     name is appended to form the complete command line.

`CXXLINK'
     The command used to actually link a C++ program.

Automatic de-ANSI-fication
==========================

   Although the GNU standards allow the use of ANSI C, this can have the
effect of limiting portability of a package to some older compilers
(notably SunOS).

   Automake allows you to work around this problem on such machines by
"de-ANSI-fying" each source file before the actual compilation takes
place.

   If the `Makefile.am' variable `AUTOMAKE_OPTIONS' (see Options)
contains the option `ansi2knr' then code to handle de-ANSI-fication is
inserted into the generated `Makefile.in'.

   This causes each C source file in the directory to be treated as
ANSI C.  If an ANSI C compiler is available, it is used.  If no ANSI C
compiler is available, the `ansi2knr' program is used to convert the
source files into K&R C, which is then compiled.

   The `ansi2knr' program is simple-minded.  It assumes the source code
will be formatted in a particular way; see the `ansi2knr' man page for
details.

   De-ANSI-fication support requires the source files `ansi2knr.c' and
`ansi2knr.1' to be in the same package as the ANSI C source; these
files are distributed with Automake.  Also, the package `configure.in'
must call the macro `AM_C_PROTOTYPES'.

   Automake also handles finding the `ansi2knr' support files in some
other directory in the current package.  This is done by prepending the
relative path to the appropriate directory to the `ansi2knr' option.
For instance, suppose the package has ANSI C code in the `src' and
`lib' subdirs.  The files `ansi2knr.c' and `ansi2knr.1' appear in
`lib'.  Then this could appear in `src/Makefile.am':

     AUTOMAKE_OPTIONS = ../lib/ansi2knr

   If no directory prefix is given, the files are assumed to be in the
current directory.

Automatic dependency tracking
=============================

   As a developer it is often painful to continually update the
`Makefile.in' whenever the include-file dependencies change in a
project.  `automake' supplies a way to automatically track dependency
changes, and distribute the dependencies in the generated `Makefile.in'.

   Currently this support requires the use of GNU `make' and `gcc'.  It
might become possible in the future to supply a different dependency
generating program, if there is enough demand.  In the meantime, this
mode is enabled by default if any C program or library is defined in
the current directory, so you may get a `Must be a separator' error
from non-GNU make.

   When you decide to make a distribution, the `dist' target will
re-run `automake' with `--include-deps' and other options.  This will
cause the previously generated dependencies to be inserted into the
generated `Makefile.in', and thus into the distribution.  This step
also turns off inclusion of the dependency generation code, so that
those who download your distribution but don't use GNU `make' and `gcc'
will not get errors.

   When added to the `Makefile.in', the dependencies have all
system-specific dependencies automatically removed.  This can be done by
listing the files in `OMIT_DEPENDENCIES'.  For instance all references
to system header files are removed by `automake'.  Sometimes it is
useful to specify that a certain header file should be removed.  For
instance if your `configure.in' uses `AM_WITH_REGEX', then any
dependency on `rx.h' or `regex.h' should be removed, because the
correct one cannot be known until the user configures the package.

   As it turns out, `automake' is actually smart enough to the
particular case of the regular expression header.  It will also
automatically omit `libintl.h' if `AM_GNU_GETTEXT' is used.

   Automatic dependency tracking can be suppressed by putting
`no-dependencies' in the variable `AUTOMAKE_OPTIONS'.

   If you unpack a distribution made by `make dist', and you want to
turn on the dependency-tracking code again, simply re-run `automake'.

   The actual dependency files are put under the build directory, in a
subdirectory named `.deps'.  These depencencies are machine specific.
It is safe to delete them if you like; they will be automatically
recreated during the next build.

Other Derived Objects
*********************

   Automake can handle derived objects which are not C programs.
Sometimes the support for actually building such objects must be
explicitly supplied, but Automake will still automatically handle
installation and distribution.

Executable Scripts
==================

   It is possible to define and install programs which are scripts.
Such programs are listed using the `SCRIPTS' primary name.  `automake'
doesn't define any dependencies for scripts; the `Makefile.am' should
include the appropriate rules.

   `automake' does not assume that scripts are derived objects; such
objects must be deleted by hand; see Clean for more information.

   `automake' itself is a script that is generated at configure time
from `automake.in'.  Here is how this is handled:

     bin_SCRIPTS = automake

   Since `automake' appears in the `AC_OUTPUT' macro, a target for it
is automatically generated.

   Script objects can be installed in `bindir', `sbindir',
`libexecdir', or `pkgdatadir'.

Header files
============

   Header files are specified by the `HEADERS' family of variables.
Generally header files are not installed, so the `noinst_HEADERS'
variable will be the most used.

   All header files must be listed somewhere; missing ones will not
appear in the distribution.  Often it is clearest to list uninstalled
headers with the rest of the sources for a program.  See A Program.
Headers listed in a `_SOURCES' variable need not be listed in any
`_HEADERS' variable.

   Headers can be installed in `includedir', `oldincludedir', or
`pkgincludedir'.

Architecture-independent data files
===================================

   Automake supports the installation of miscellaneous data files using
the `DATA' family of variables.

   Such data can be installed in the directories `datadir',
`sysconfdir', `sharedstatedir', `localstatedir', or `pkgdatadir'.

   By default, data files are not included in a distribution.

   Here is how `automake' installs its auxiliary data files:

     pkgdata_DATA = clean-kr.am clean.am ...

Built sources
=============

   Occasionally a file which would otherwise be called "source" (eg a C
`.h' file) is actually derived from some other file.  Such files should
be listed in the `BUILT_SOURCES' variable.

   Built sources are also not compiled by default.  You must either
explicitly mention them in some other `_SOURCES' variable for this to
happen.

   Note that, in some cases, `BUILT_SOURCES' will work in somewhat
suprising ways.  In order to get the built sources to work with
automatic dependency tracking, the `Makefile' must depend on
`$(BUILT_SOURCES)'.  This can cause these sources to be rebuilt at what
might seem like funny times.

Other GNU Tools
***************

   Since Automake is primarily intended to generate `Makefile.in's for
use in GNU programs, it tries hard to interoperate with other GNU tools.

Emacs Lisp
==========

   Automake provides some support for Emacs Lisp.  The `LISP' primary
is used to hold a list of `.el' files.  Possible prefixes for this
primary are `lisp_' and `noinst_'.  Note that if `lisp_LISP' is
defined, then `configure.in' must run `AM_PATH_LISPDIR' (fixme xref).

   By default Automake will byte-compile all Emacs Lisp source files
using the Emacs found by `AM_PATH_LISPDIR'.  If you wish to avoid
byte-compiling, simply define the variable `ELCFILES' to be empty.
Byte-compiled Emacs Lisp files are not portable among all versions of
Emacs, so it makes sense to turn this off if you expect sites to have
more than one version of Emacs installed.  Furthermore, many packages
don't actually benefit from byte-compilation.  Still, we recommand that
you leave it enabled by default.  It is probably better for sites with
strange setups to cope for themselves than to make the installation less
nice for everybody else.

Gettext
=======

   If `AM_GNU_GETTEXT' is seen in `configure.in', then Automake turns
on support for GNU gettext, a message catalog system for
internationalization (see GNU Gettext (gettext)).

   The `gettext' support in Automake requires the addition of two
subdirectories to the package, `intl' and `po'.  Automake ensure that
these directories exist and are mentioned in `SUBDIRS'.

   Furthermore, Automake checks that the definition of `ALL_LINGUAS' in
`configure.in' corresponds to all the valid `.po' files, and nothing
more.

Guile
=====

   Automake provides some automatic support for writing Guile modules.
Automake will turn on Guile support if the `AM_INIT_GUILE_MODULE' macro
is used in `configure.in'.

   Right now Guile support just means that the `AM_INIT_GUILE_MODULE'
macro is understood to mean:
   * `AM_INIT_AUTOMAKE' is run.

   * `AC_CONFIG_AUX_DIR' is run, with a path of `..'.

   As the Guile module code matures, no doubt the Automake support will
grow as well.

Libtool
=======

   Automake provides support for GNU Libtool (see The Libtool Manual (libtool))
with the `LTLIBRARIES' primary.  See A Shared Library.

Building documentation
**********************

   Currently Automake provides support for Texinfo and man pages.

Texinfo
=======

   If the current directory contains Texinfo source, you must declare it
with the `TEXINFOS' primary.  Generally Texinfo files are converted
into info, and thus the `info_TEXINFOS' macro is most commonly used
here.  Note that any Texinfo source file must end in the `.texi' or
`.texinfo' extension.

   If the `.texi' file `@include's `version.texi', then that file will
be automatically generated.  `version.texi' defines three Texinfo
macros you can reference: `EDITION', `VERSION', and `UPDATED'.  The
first two hold the version number of your package (but are kept
separate for clarity); the last is the date the primary file was last
modified.  The `version.texi' support requires the `mdate-sh' program;
this program is supplied with Automake.

   Sometimes an info file actually depends on more than one `.texi'
file.  For instance, in GNU Hello, `hello.texi' includes the file
`gpl.texi'.  You can tell Automake about these dependencies using the
`TEXI_TEXINFOS' variable.  Here is how Hello does it:

     info_TEXINFOS = hello.texi
     hello_TEXINFOS = gpl.texi

   By default, Automake requires the file `texinfo.tex' to appear in
the same directory as the Texinfo source.  However, if you used
`AC_CONFIG_AUX_DIR' in `configure.in', then `texinfo.tex' is looked for
there.  Automake supplies `texinfo.tex' if `--add-missing' is given.

   If your package has Texinfo files in many directories, you can use
the variable `TEXINFO_TEX' to tell automake where to find the canonical
`texinfo.tex' for your package.  The value of this variable should be
the relative path from the current `Makefile.am' to `texinfo.tex':

     TEXINFO_TEX = ../doc/texinfo.tex

   The option `no-texinfo.tex' can be used to eliminate the requirement
for `texinfo.tex'.  Use of the variable `TEXINFO_TEX' is preferable,
however, because that allows the `dvi' target to still work.

   Automake generates an `install-info' target; some people apparently
use this.  By default, info pages are installed by `make install'.
This can be prevented via the `no-installinfo' option.

Man pages
=========

   A package can also include man pages.  (Though see the GNU standards
on this matter, see Man Pages (standards).)  Man pages are
declared using the `MANS' primary.  Generally the `man_MANS' macro is
used.  Man pages are automatically installed in the correct
subdirectory of `mandir', based on the file extension.

   By default, man pages are installed by `make install'.  However,
since the GNU project does not require man pages, many maintainers do
not expend effort to keep the man pages up to date.  In these cases, the
`no-installman' option will prevent the man pages from being installed
by default.  The user can still explicitly install them via `make
install-man'.

   Here is how the documentation is handled in GNU `cpio' (which
includes both Texinfo documentation and man pages):

     info_TEXINFOS = cpio.texi
     man_MANS = cpio.1 mt.1

   Texinfo source and info pages are all considered to be source for the
purposes of making a distribution.

   Man pages are not currently considered to be source, because it is
not uncommon for man pages to be automatically generated.

What Gets Installed
*******************

   Naturally, Automake handles the details of actually installing your
program once it has been built.  All `PROGRAMS', `SCRIPTS',
`LIBRARIES', `LISP', `DATA' and `HEADERS' are automatically installed
in the appropriate places.

   Automake also handles installing any specified info and man pages.

   Automake generates separate `install-data' and `install-exec'
targets, in case the installer is installing on multiple machines which
share directory structure--these targets allow the machine-independent
parts to be installed only once.  The `install' target depends on both
of these targets.

   Automake also generates an `uninstall' target, and an `installdirs'
target.

   It is possible to extend this mechanism by defining an
`install-exec-local' or `install-data-local' target.  If these targets
exist, they will be run at `make install' time.

   Variables using the standard directory prefixes `data', `info',
`man', `include', `oldinclude', `pkgdata', or `pkginclude' (eg
`data_DATA') are installed by `install-data'.

   Variables using the standard directory prefixes `bin', `sbin',
`libexec', `sysconf', `localstate', `lib', or `pkglib' (eg
`bin_PROGRAMS') are installed by `install-exec'.

   Any variable using a user-defined directory prefix with `exec' in
the name (eg `myexecbin_PROGRAMS' is installed by `install-exec'.  All
other user-defined prefixes are installed by `install-data'.

What Gets Cleaned
*****************

   The GNU Makefile Standards specify a number of different clean rules.
Generally the files that can cleaned are determined automatically by
Automake.  Of course, Automake also recognizes some variables that can
be defined to specify additional files to clean.  These variables are
`MOSTLYCLEANFILES', `CLEANFILES', `DISTCLEANFILES', and
`MAINTAINERCLEANFILES'.

What Goes in a Distribution
***************************

   The `dist' target in the generated `Makefile.in' can be used to
generate a gzip'd `tar' file for distribution.  The tar file is named
based on the `PACKAGE' and `VERSION' variables; more precisely it is
named `PACKAGE-VERSION.tar.gz'.

   For the most part, the files to distribute are automatically found by
Automake: all source files are automatically included in a distribution,
as are all `Makefile.am's and `Makefile.in's.  Automake also has a
built-in list of commonly used files which, if present in the current
directory, are automatically included.  This list is printed by
`automake --help'.  Also, files which are read by `configure' (ie, the
source files corresponding to the files specified in the `AC_OUTPUT'
invocation) are automatically distributed.

   Still, sometimes there are files which must be distributed, but which
are not covered in the automatic rules.  These files should be listed in
the `EXTRA_DIST' variable.  Note that `EXTRA_DIST' can only handle
files in the current directory; files in other directories will cause
`make dist' runtime failures.

   If you define `SUBDIRS', automake will recursively include the
subdirectories in the distribution.  If `SUBDIRS' is defined
conditionally (see Conditionals.), automake will normally include
all directories that could possibly appear in `SUBDIRS' in the
distribution.  If you need to specify the set of directories
conditionally, you can set the variable `DIST_SUBDIRS' to the exact
list of subdirectories to include in the distribution.

   Occasionally it is useful to be able to change the distribution
before it is packaged up.  If the `dist-hook' target exists, it is run
after the distribution directory is filled, but before the actual tar
(or shar) file is created.  One way to use this is for distributing
files in subdirectories for which a new `Makefile.am' is overkill:

     dist-hook:
             mkdir $(distdir)/random
             cp -p random/a1 random/a2 $(distdir)/random

   Automake also generates a `distcheck' target which can be help to
ensure that a given distribution will actually work.  `distcheck' makes
a distribution, and then tries to do a `VPATH' build.

Support for test suites
***********************

   Automake supports a two forms of test suite.

   If the variable `TESTS' is defined, its value is taken to be a list
of programs to run in order to do the testing.  The programs can either
be derived objects or source objects; the generated rule will look both
in SRCDIR and `.'.

   The number of failures will be printed at the end of the run.  If a
given test program exits with a status of 77, then its result is ignored
in the final count.  This feature allows non-portable tests to be
ignored in environments where they don't make sense.

   The variable `TESTS_ENVIRONMENT' can be used to set environment
variables for the test run; the environment variable `srcdir' is set in
the rule.  If all your test programs are scripts, you can also set
`TESTS_ENVIRONMENT' to an invocation of the shell (eg `$(SHELL) -x');
this can be useful for debugging the tests.

   If `dejagnu' appears in `AUTOMAKE_OPTIONS', then the a
`dejagnu'-based test suite is assumed.  The value of the variable
`DEJATOOL' is passed as the `--tool' argument to `runtest'; it defaults
to the name of the package.  The variables `EXPECT', `RUNTEST' and
`RUNTESTFLAGS' can also be overridden to provide project-specific
values.  For instance, you will need to do this if you are testing a
compiler toolchain, because the default values do not take into account
host and target names.

   In either case, the testing is done via `make check'.

Changing Automake's Behavior
****************************

   Various features of Automake can be controlled by options in the
`Makefile.am'.  Such options are listed in a special variable named
`AUTOMAKE_OPTIONS'.  Currently understood options are:

`gnits'
`gnu'
`foreign'
     Set the strictness as appropriate.

`no-installman'
     The generated `Makefile.in' will not cause man pages to be
     installed by default.  However, an `install-man' target will still
     be available for optional installation.  This option is disallowed
     at `GNU' strictness and above.

`no-installinfo'
     The generated `Makefile.in' will not cause info pages to be built
     or installed by default.  However, `info' and `install-info'
     targets will still be available.  This option is disallowed at
     `GNU' strictness and above.

`ansi2knr'
`path/ansi2knr'
     Turn on automatic de-ANSI-fication.  See ANSI.  If preceeded
     by a path, the generated `Makefile.in' will look in the specified
     directory to find the `ansi2knr' program.  Generally the path
     should be a relative path to another directory in the same
     distribution (though Automake currently does not check this).

`dejagnu'
     Cause `dejagnu'-specific rules to be generated.  See Tests.

`dist-shar'
     Generate a `dist-shar' target as well as the ordinary `dist'
     target.  This new target will create a shar archive of the
     distribution.

`dist-zip'
     Generate a `dist-zip' target as well as the ordinary `dist'
     target.  This new target will create a zip archive of the
     distribution.

`dist-tarZ'
     Generate a `dist-tarZ' target as well as the ordinary `dist'
     target.  This new target will create a compressed tar archive of
     the distribution; a traditional `tar' and `compress' will be
     assumed.  Warning: if you are actually using `GNU tar', then the
     generated archive might contain nonportable constructs.

`no-dependencies'
     This is similar to using `--include-deps' on the command line, but
     is useful for those situations where you don't have the necessary
     bits to make automatic dependency tracking work
     Dependencies.  In this case the effect is to effectively disable
     automatic dependency tracking.

`no-texinfo.tex'
     Don't require `texinfo.tex', even if there are texinfo files in
     this directory.

VERSION
     A version number (eg `0.30') can be specified.  If Automake is not
     newer than the version specified, creation of the `Makefile.in'
     will be suppressed.

   Unrecognized options are diagnosed by `automake'.

Miscellaneous Rules
*******************

   There are a few rules and variables that didn't fit anywhere else.

Interfacing to `etags'
======================

   `automake' will generate rules to generate `TAGS' files for use with
GNU Emacs under some circumstances.

   If any C source code or headers are present, then `tags' and `TAGS'
targets will be generated for the directory.

   At the topmost directory of a multi-directory package, a `tags'
target file will be generated which, when run, will generate a `TAGS'
file that includes by reference all `TAGS' files from subdirectories.

   Also, if the variable `ETAGS_ARGS' is defined, a `tags' target will
be generated.  This variable is intended for use in directories which
contain taggable source that `etags' does not understand.

   Here is how Automake generates tags for its source, and for nodes in
its Texinfo file:

     ETAGS_ARGS = automake.in --lang=none \
      --regex='/^@node[ \t]+\([^,]+\)/\1/' automake.texi

   If you add filenames to `ETAGS_ARGS', you will probably also want to
set `TAGS_DEPENDENCIES'.  The contents of this variable are added
directly to the dependencies for the `tags' target.

   Automake will also generate an `ID' target which will run `mkid' on
the source.  This is only supported on a directory-by-directory basis.

Handling new file extensions
============================

   It is sometimes useful to introduce a new implicit rule to handle a
file type that Automake does not know about.  If this is done, you must
notify GNU Make of the new suffixes.  This can be done by putting a list
of new suffixes in the `SUFFIXES' variable.

   For instance, currently automake does not provide any Java support.
If you wrote a macro to generate `.class' files from `.java' source
files, you would also need to add these suffixes to the list:

     SUFFIXES = .java .class

Conditionals
************

   Automake supports a simple type of conditionals.

   Before using a conditional, you must define it by using
`AM_CONDITIONAL' in the `configure.in' file.  The `AM_CONDITIONAL'
macro takes two arguments.

   The first argument to `AM_CONDITIONAL' is the name of the
conditional.  This should be a simple string starting with a letter and
containing only letters, digits, and underscores.

   The second argument to `AM_CONDITIONAL' is a shell condition,
suitable for use in a shell if statement.  The condition is evaluated
when `configure' is run.

   Conditionals typically depend upon options which the user provides to
the `configure' script.  Here is an example of how to write a
conditional which is true if the user uses the `--enable-debug' option.

     AC_ARG_ENABLE(debug,
     [  --enable-debug    Turn on debugging],
     [case "${enableval}" in
       yes) debug=true ;;
       no)  debug=false ;;
       *) AC_MSG_ERROR(bad value ${enableval} for --enable-debug) ;;
     esac],[debug=false])
     AM_CONDITIONAL(DEBUG, test x$debug = xtrue)

   Here is an example of how to use that conditional in `Makefile.am':

     if DEBUG
     DBG = debug
     else
     DBG =
     endif
     noinst_PROGRAMS = $(DBG)

   This trivial example could also be handled using EXTRA_PROGRAMS
(see A Program.).

   You may only test a single variable in an `if' statement.  The
`else' statement may be omitted.  Conditionals may be nested to any
depth.

   Note that conditionals in Automake are not the same as conditionals
in GNU Make.  Automake conditionals are checked at configure time by the
`configure' script, and affect the translation from `Makefile.in' to
`Makefile'.  They are based on options passed to `configure' and on
results that `configure' has discovered about the host system.  GNU
Make conditionals are checked at make time, and are based on variables
passed to the make program or defined in the `Makefile'.

   Automake conditionals will work with any make program.

The effect of `--gnu' and `--gnits'
***********************************

   The `--gnu' option (or `gnu' in the `AUTOMAKE_OPTIONS' variable)
causes `automake' to check the following:

   * The files `INSTALL', `NEWS', `README', `COPYING', `AUTHORS', and
     `ChangeLog' are required at the topmost directory of the package.

   * The options `no-installman' and `no-installinfo' are prohibited.

   Note that this option will be extended in the future to do even more
checking; it is advisable to be familiar with the precise requirements
of the GNU standards.  Also, `--gnu' can require certain non-standard
GNU programs to exist for use by various maintainer-only targets; for
instance in the future `pathchk' might be required for `make dist'.

   The `--gnits' option does everything that `--gnu' does, and checks
the following as well:

   * `make dist' will check to make sure the `NEWS' file has been
     updated to the current version.

   * The file `COPYING.LIB' is prohibited.  The LGPL is apparently
     considered a failed experiment.

   * `VERSION' is checked to make sure its format complies with Gnits
     standards.

   * If `VERSION' indicates that this is an alpha release, and the file
     `README-alpha' appears in the topmost directory of a package, then
     it is included in the distribution.  This is done in `--gnits'
     mode, and no other, because this mode is the only one where version
     number formats are constrained, and hence the only mode where
     `automake' can automatically determine whether `README-alpha'
     should be included.

   * The file `THANKS' is required.

The effect of `--cygnus'
************************

   Cygnus Solutions has slightly different rules for how a
`Makefile.in' is to be constructed.  Passing `--cygnus' to `automake'
will cause any generated `Makefile.in' to comply with Cygnus rules.

   Here are the precise effects of `--cygnus':

   * Info files are always created in the build directory, and not in
     the source directory.

   * `texinfo.tex' is not required if a Texinfo source file is
     specified.  The assumption is that the file will be supplied, but
     in a place that `automake' cannot find.  This assumption is an
     artifact of how Cygnus packages are typically bundled.

   * `make dist' will look for files in the build directory as well as
     the source directory.  This is required to support putting info
     files into the build directory.

   * Certain tools will be searched for in the build tree as well as in
     the user's `PATH'.  These tools are `runtest', `expect',
     `makeinfo' and `texi2dvi'.

   * `--foreign' is implied.

   * The options `no-installinfo' and `no-dependencies' are implied.

   * The macros `AM_MAINTAINER_MODE' and `AM_CYGWIN32' are required.

   GNU maintainers are advised to use `gnu' strictness in preference to
the special Cygnus mode.

When Automake Isn't Enough
**************************

   Automake's implicit copying semantics means that many problems can be
worked around by simply adding some `make' targets and rules to
`Makefile.in'.  `automake' will ignore these additions.

   There are some caveats to doing this.  Although you can overload a
target already used by `automake', it is often inadvisable,
particularly in the topmost directory of a non-flat package.  However,
various useful targets have a `-local' version you can specify in your
`Makefile.in'.  Automake will supplement the standard target with these
user-supplied targets.

   The targets that support a local version are `all', `info', `dvi',
`check', `install-data', `install-exec', `uninstall', and the various
`clean' targets (`mostlyclean', `clean', `distclean', and
`maintainer-clean').  Note that there are no `uninstall-exec-local' or
`uninstall-data-local' targets; just use `uninstall-local'.  It doesn't
make sense to uninstall just data or just executables.

   For instance, here is one way to install a file in `/etc':

     install-data-local:
             $(INSTALL_DATA) $(srcdir)/afile /etc/afile

   Some targets also have a way to run another target, called a "hook",
after their work is done.  The hook is named after the principal target,
with `-hook' appended.  The targets allowing hooks are `install-data',
`install-exec', `dist', and `distcheck'.

   For instance, here is how to create a hard link to an installed
program:

     install-exec-hook:
             ln $(bindir)/program $(bindir)/proglink

Distributing `Makefile.in's
***************************

   Automake places no restrictions on the distribution of the resulting
`Makefile.in's.  We still encourage software authors to distribute
their work under terms like those of the GPL, but doing so is not
required to use Automake.

   Some of the files that can be automatically installed via the
`--add-missing' switch do fall under the GPL; examine each file to see.

Some ideas for the future
*************************

   Here are some things that might happen in the future:

   * HTML support.

   * The output will be cleaned up.  For instance, only variables which
     are actually used will appear in the generated `Makefile.in'.

   * There will be support for automatically recoding a distribution.
     The intent is to allow a maintainer to use whatever character set
     is most convenient locally, but for all distributions to be
     Unicode or ISO 10646 with the UTF-8 encoding.

   * Support for automatically generating packages (eg Debian packages,
     RPM packages, Solaris packages, etc).  This will happen more
     quickly if someone with package-building experience can tell me
     what would be helpful.

   * Rewrite in Guile.  This won't happen in the near future, but it
     will eventually happen.